﻿using System.Net.Http.Json;
using System.Text.Json.Serialization;
using System.Text.RegularExpressions;

namespace TestMVVM.Services;

public class SampleDataService : IDAOService<Alumno>
{
    private string baseUrl = "http://localhost:3001/alumno";
    private HttpClient client = new HttpClient();

    public async Task<bool> AddItem(Alumno item)
    {
        HttpRequestMessage message = new HttpRequestMessage(HttpMethod.Post, baseUrl);
        message.Content = JsonContent.Create<Alumno>(item);

        HttpResponseMessage response = await client.SendAsync(message);
        return response.IsSuccessStatusCode;
    }

    public async Task<bool> DeleteItem(int id)
    {
        HttpRequestMessage message = new HttpRequestMessage(HttpMethod.Delete, baseUrl + "/" + id);

        HttpResponseMessage response = await client.SendAsync(message);
        return response.IsSuccessStatusCode;
    }

    public async Task<Alumno> GetItem(int id)
    {
        string text = await client.GetStringAsync(baseUrl + "/" + id);
        Alumno alumno = JsonSerializer.Deserialize<Alumno>(text);
        return alumno;
    }

    public async Task<IEnumerable<Alumno>> GetItems()
	{
        IEnumerable<Alumno> alumnos = null;
        try { 
	  
        
            var text = await client.GetStringAsync(baseUrl);
         
        alumnos = JsonSerializer.Deserialize<IEnumerable<Alumno>>(text);
            
        } catch(Exception ex)
        {
            Console.WriteLine(ex.Message);  
        }


        return alumnos;
	}

    public async Task<bool> UpdateItem(Alumno item)
    {
        HttpRequestMessage message = new HttpRequestMessage(HttpMethod.Put, baseUrl + "/" + item.id);
        message.Content = JsonContent.Create<Alumno>(item);

        HttpResponseMessage response = await client.SendAsync(message);
        return response.IsSuccessStatusCode;
    }
}
